<?php
namespace Teknisa\FIS\Controllers;

use Teknisa\FIS\Services\Fis25000ParametrizacaoContribuicoesService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;


class Fis25000ParametrizacaoContribuicoesController extends \Teknisa\FIS\Controllers\TeknisaCrud{

    protected $dataSourceName;
    protected $parameterBag;
    protected $crudService;
    protected $dataSourceNameToSave  = false;
    protected $service;

    public function __construct($crudService, ParameterBag $parameterBag, Fis25000ParametrizacaoContribuicoesService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }


    public function salvarOutrasContribuicoes(DTO\Request $request, DTO\Response $response) {
        try {
            $rows = $this->crudService->getRowsToSave($request, $request->getRow()['dataSourceName'] == "fis#/crud/outcrecont"?'outcrecont':'outreccont');
            $this->service->salvarOutrasContribuicoes($rows[0]);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function deletarOutrasContribuicoes(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->service->deletarOutrasContribuicoes($row);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function salvarContaContabil(DTO\Request $request, DTO\Response $response) {
        try {
            
            $rowOutrasContribuicoes = $request->getRow()['rowOutrasContribuicoes'];
            $dataSourceName = $request->getRow()['dataSourceName'] == "fis#/crud/outcrecontctbl_contctbl"?'outcrecontctbl':'outreccontctbl'; 
            $rowConta = $this->crudService->getRowsToSave($request, $dataSourceName);

            $this->service->salvarContaContabil($rowConta,$rowOutrasContribuicoes,$dataSourceName);

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function salvarBenfeitoria(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $this->crudService->getRowsToSave($request, 'benfeitoria');
            $this->service->salvarBenfeitoria($row);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function salvarImportacao(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->service->salvarImportacao($row);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    

}
