<?php
namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;

class Ger01200EstadoFactory {
    #default service
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();

    }
    public function verficaNomeEstado($row) {
        $params           = array();
        $params['NRORG']  = $row['NRORG'];
        $params['CDPAIS']  = $row['CDPAIS'];
       	$params['NMESTADO'] = strtolower($row['NMESTADO']);

        $sql = "SELECT *
                  	FROM ESTADO
                	WHERE (NRORG = :NRORG OR NRORG = 0) AND CDPAIS = :CDPAIS AND LOWER(NMESTADO) = :NMESTADO";


        $std = $this->connection->prepare($sql);
        $std->execute($params);


        return $std->fetchAll();
    }
    
    public function verficaSiglaEstado($row) {
        $params             = array();
        $params['NRORG']    = $row['NRORG'];
       	$params['CDPAIS']   = $row['CDPAIS'];
       	$params['SGESTADO'] = $row['SGESTADO'];

        $sql = "SELECT *
                  	FROM ESTADO
                	WHERE (NRORG = :NRORG OR NRORG = 0) AND CDPAIS = :CDPAIS AND SGESTADO = :SGESTADO";


        $std = $this->connection->prepare($sql);
        $std->execute($params);


        return $std->fetchAll();
    }


}